export const groupBy = (data, compare) => {
    const result = [];
    let currentGroup = undefined;
    for (const element of stableSort(data.slice(0), compare)) {
        if (!currentGroup || compare(currentGroup[0], element) !== 0) {
            currentGroup = [element];
            result.push(currentGroup);
        }
        else {
            currentGroup.push(element);
        }
    }
    return result;
};
export const stableSort = (data, compare) => {
    _sort(data, compare, 0, data.length - 1, []);
    return data;
};
function _merge(a, compare, lo, mid, hi, aux) {
    let leftIdx = lo;
    let rightIdx = mid + 1;
    for (let i = lo; i <= hi; i++)
        aux[i] = a[i];
    for (let i = lo; i <= hi; i++) {
        if (leftIdx > mid) {
            // left side consumed
            a[i] = aux[rightIdx++];
        }
        else if (rightIdx > hi) {
            // right side consumed
            a[i] = aux[leftIdx++];
        }
        else if (compare(aux[rightIdx], aux[leftIdx]) < 0) {
            // right element is less -> comes first
            a[i] = aux[rightIdx++];
        }
        else {
            // left element comes first (less or equal)
            a[i] = aux[leftIdx++];
        }
    }
}
function _sort(a, compare, lo, hi, aux) {
    if (hi <= lo)
        return;
    const mid = (lo + (hi - lo) / 2) | 0;
    _sort(a, compare, lo, mid, aux);
    _sort(a, compare, mid + 1, hi, aux);
    // left and right are sorted and if the last-left element is less
    // or equals than the first-right element there is nothing else
    // to do
    if (compare(a[mid], a[mid + 1]) <= 0)
        return;
    _merge(a, compare, lo, mid, hi, aux);
}
//# sourceMappingURL=array.js.map