import { SnippetParser, Text, Placeholder, Variable, Choice, } from "./snippetParser";
const check = (s) => {
    const snippet = new SnippetParser().parse(s, true);
    console.log(s);
    console.log(snippet.toString());
    for (const p of snippet.placeholders) {
        const placeholderOffset = snippet.offset(p);
        const placeholderLen = snippet.fullLen(p);
        console.log({
            index: p.index,
            placeholderOffset,
            placeholderLen,
            final: p.isFinalTabstop,
        });
    }
    // console.log(inspect(snippet.children, { depth: null }));
    // console.log(serializeSnippet(s));
    // console.log(inspect(serializeSnippet(s), { depth: null }));
    // console.log(snippet.placeholders);
    // console.log(snippet.toTextmateString());
};
const serializeSnippet = (s) => {
    const snippet = new SnippetParser().parse(s, true);
    return snippet.children.map(serializeMarker);
};
const serializeMarker = (s) => {
    var _a, _b;
    if (s instanceof Text) {
        return { type: "text", value: s.value };
    }
    if (s instanceof Placeholder) {
        return {
            type: "placeholder",
            index: s.index,
            transform: (_a = s.transform) === null || _a === void 0 ? void 0 : _a.toTextmateString(),
            children: s.children.map(serializeMarker),
        };
    }
    if (s instanceof Choice) {
        return {
            type: "choice",
            options: s.options.map((t) => t.value),
        };
    }
    if (s instanceof Variable) {
        return {
            type: "variable",
            name: s.name,
            transform: (_b = s.transform) === null || _b === void 0 ? void 0 : _b.toTextmateString(),
        };
    }
    return { type: "other", value: s.toTextmateString() };
};
console.log(check('"${1:my-third-party-library}": "${2:1.2.3}"'));
console.log(check('"$1": "$1${2:1.2.3}"'));
console.log(check("${1:another ${2:placeholder}}"));
console.log(check("${1|one,two,three|}"));
console.log(check("${name:default}"));
console.log(check("${TM_FILENAME/(.*)\\..+$/$1/}"));
//# sourceMappingURL=check-parser.js.map